function traduz(idioma, mensagem){
	mensagens_para_traducao = {
		'pt_br': {
			'SEM_RECEITA': 'Prato __PARAM0__ não possui receita',
			'SOMENTE_RECEITA_PADRAO': 'Prato __PARAM0__ possui apenas receita padrão e unidade requer receita local ou por serviço',
			'PRATO_INATIVO': 'Prato __PARAM0__ está inativo',
			'RECEITA_PADRAO_INATIVA': 'Receita padrão do prato __PARAM0__ está inativa',
			'RECEITA_LOCAL_INATIVA': 'Receita local do prato __PARAM0__ está inativa',
			'RECEITA_SERVICO_INATIVA': 'Receita por serviço do prato __PARAM0__ está inativa',
			'PRODUTO_PADRAO_INATIVO': 'Produto __PARAM1__ da receita padrão do prato __PARAM0__ está inativo',
			'PRODUTO_LOCAL_INATIVO': 'Produto __PARAM1__ da receita local do prato __PARAM0__ está inativo',
			'PRODUTO_SERVICO_INATIVO': 'Produto __PARAM1__ da receita por serviço do prato __PARAM0__ está inativo',
			'CARDAPIO_EM_ANDAMENTO': 'Cardápio de destino já foi iniciado',
			'ORIGEM_IGUAL_DESTINO': 'Cardápio de origem não pode ser utilizado como destino da replicação',
			'CUSTO_PADRAO_N_CAD': 'Custo padrão não cadastrado no serviço para o mês',
			'CARD_N_LIBERADO_MATRIZ': 'Cardápio não liberado pela matriz para o mês',
			'CARD_JA_APROVADO_FILIAL': 'Cardápio já aprovado pela unidade',
			'CARD_JA_APROVADO_MATRIZ': 'Cardápio já aprovado pela matriz',
			'LIMITE_APROVACAO_EXPIRADO_FILIAL': 'Data limite de aprovação da unidade expirou',
			'EXISTE_RETIRADA': 'Dia __PARAM0__ possui retirada lançada',
			'EXISTE_FATURAMENTO_PLA': 'Dia __PARAM0__ possui efetivos de planejamento já apurados',
			'EXISTE_FATURAMENTO_FAI': 'Dia __PARAM0__ possui efetivos de faturamento já apurados',
			'EXISTE_DISTRIBUICAO': 'Dia __PARAM0__ possui distribuição de embalagens lançada',
			'PRATO_AGENDADO_INATIVACAO': 'Prato __PARAM0__ não relacionado ao dia __PARAM1__ pois foi agendado para inativação em __PARAM2__',
			'RECEITA_PADRAO_AGENDADA_INATIVACAO': 'Prato __PARAM0__ não relacionado ao dia __PARAM1__ pois sua receita padrão foi agendada para inativação em __PARAM2__',
			'RECEITA_LOCAL_AGENDADA_INATIVACAO': 'Prato __PARAM0__ não relacionado ao dia __PARAM1__ pois sua receita local foi agendada para inativação em __PARAM2__',
			'RECEITA_SERVICO_AGENDADA_INATIVACAO': 'Prato __PARAM0__ não relacionado ao dia __PARAM1__ pois sua receita por serviço foi agendada para inativação em __PARAM2__',
			'COMENSAIS_SEG_N_CAD': 'Comensais não cadastrados no serviço que atendam o dia __PARAM0__ (segunda-feira)',
			'COMENSAIS_TER_N_CAD': 'Comensais não cadastrados no serviço que atendam o dia __PARAM0__ (terça-feira)',
			'COMENSAIS_QUA_N_CAD': 'Comensais não cadastrados no serviço que atendam o dia __PARAM0__ (quarta-feira)',
			'COMENSAIS_QUI_N_CAD': 'Comensais não cadastrados no serviço que atendam o dia __PARAM0__ (quinta-feira)',
			'COMENSAIS_SEX_N_CAD': 'Comensais não cadastrados no serviço que atendam o dia __PARAM0__ (sexta-feira)',
			'COMENSAIS_SAB_N_CAD': 'Comensais não cadastrados no serviço que atendam o dia __PARAM0__ (sábado)',
			'COMENSAIS_DOM_N_CAD': 'Comensais não cadastrados no serviço que atendam o dia __PARAM0__ (domingo)',
			'COMENSAIS_FER_N_CAD': 'Comensais não cadastrados no serviço que atendam o dia __PARAM0__ (feriado)'
		}
	}
	try {
		codeStart = mensagem.indexOf("_MSGSTA_");
		codeEnd	= mensagem.indexOf("_MSGEND_");
		idioma = idioma.toLowerCase();
		if (codeStart >= 0 && codeEnd >= 0){
			msgStart = codeStart + "_MSGSTA_".length;
			msgEnd = codeEnd;

	      paramstring = mensagem.substring(msgStart, msgEnd);

	      params = paramstring.split("$$");

	      msgcode = params.shift(params);	  
	      resultado = mensagens_para_traducao[idioma][msgcode];  
	      
	      if(params.length > 0){            
	         for(i = 0; i < params.length; i++) {
	         	padrao = new RegExp('__PARAM' + i + '__', 'g');
	         	resultado = resultado.replace(padrao, params[i]);
	         }            
	      }	  
	        
	      return resultado;
		}
	}
	catch(e){
		return mensagem;
	}
	return mensagem;
}